struct OGLVertex{

};


struct CNCVertex : public OGLVertex{ //coord normal color vertex
    QVector3D coord;
    QVector3D normal;
    QVector3D color;

    CNCVertex(){}

    CNCVertex(Vec3f coord, const Vec3f& normal, const Color3f& color):
        coord(coord.x, coord.y, coord.z),
        normal(normal.x, normal.y, normal.z),
        color(color.r, color.g, color.b)
    {}
    ~CNCVertex(){}

    static QOpenGLShaderProgram program;

    static GLuint m_coord;
    static GLuint m_normal;
    static GLuint m_color;
    static GLuint m_matrixUniform;

    static void renderNode(Render* render, QMatrix4x4& matrix, QMatrix4x4& projection, QQuaternion& rotation, QMatrix4x4& qRotMatrix);
};



class Render {
public:

    OGLVertex* pVB;
    GLushort*  pIB;
    int vertexCount;
    int indexCount;
    int type;
    Render() :
        pVB(0),
        pIB(0),
        vertexCount(0),
        indexCount(0),
        type(0),

        indexBuf(QOpenGLBuffer(QOpenGLBuffer::IndexBuffer))

    {}

    QOpenGLBuffer arrayBuf;
    QOpenGLBuffer indexBuf;

    static bool initShader(QOpenGLShaderProgram& program, const char* vshaderFile, const char* fshaderFile);

    void convertToRenderFormatCNC(const M_Vec3f& coord, const M_Vec3f& normal, M_Color3f& color, M_Int& coordIndex);
};
