#ifdef GL_ES
// Set default precision to medium
precision mediump int;
precision mediump float;
#endif

uniform mat4 mvp_matrix;
uniform mat4 u_normalMatrix;

attribute vec4 a_coord;
attribute vec3 a_normal;
attribute vec3 a_color;

varying vec3 v_normal;
varying vec3 v_color;
varying float v_Dot;

varying vec4 vWorldSpaceNormal;

//! [0]
void main(){
    // Calculate vertex position in screen space
    gl_Position = mvp_matrix * a_coord;

    // Pass texture coordinate to fragment shader
    // Value will be automatically interpolated to fragments inside polygon faces
    v_color = a_color;

    vec4 transNormal = u_normalMatrix * vec4(a_normal, 1);
    v_Dot = max(dot(transNormal.xyz, vec3(0.0, 0.0, 1.0)), 0.0);


    v_normal = a_normal;
}
//! [0]
